#!/usr/bin/perl -w

################################################################################
#-------------------------------------------------------------------------------
#  NAME:         checkProgress.pl
# 
#  TYPE:         perl Script 
#
#  DESCRIPTION:  Outputs the status of the system's progress.  When finished, a 
#                link is created directing towards the simulation output files.
#                
#  DEPENDENCES:  getLogFile.pm     
#     
#  INPUTS:       N/A
#      
#  OUTPUTS:      N/A
#
#  HISTORY:
# 
#-------------------------------------------------------------------------------
################################################################################


# SET FOR USAGE WITH THE CGI-BIN
use CGI;
use CGI::Carp qw(warningsToBrowser fatalsToBrowser); 
use CGI qw(:standard);

# RETRIEVE A SET OF FUNCTIONS USED TO READ AND WRITE TO 
# LOG FILES
require "getLogFile.pm";


################################
# RETRIEVE AND DEFINE THE
# INITIAL INPUT VARIABLES
################################

# RETRIEVE THE WEB-SERVER OUTPUT/DISPLAY DIRECTORY
my $sate_puff_dir = getDispDir(); 

# CHECK TO SEE IF ANOTHER PROCESS IS WAITING TO BE RUN
my $waiting4Puff = &getWaitingLog();

# RETRIEVE THE CURRENT TRANSACTION NUMBER FROM THE 'POST'
my $processNum = param("processNum");

# CHECK TO SEE IF THE PROCESSING ON THE MODEL SERVER HAS BEGUN
my $waiting2Finish = &getBegunLog();

# THE AMOUNT OF TIME (MINUTES) THAT THE CRONTAB WILL WAIT UNTIL
#   THE REQUESTS ON SATEESPANONE ARE RE-CHECKED
my $cronTab_interval = 5;




# PRINT OUT THE BEGINNING OF THE HTML FILE
print "Content-type: text/html\n\n";
print "<html>";
print "<head>";

# ARE WE CURRENTLY RUNNING THE MODEL?
if ($waiting2Finish == 1)
{

    # IF YES, THEN WRITE THE FOLLOWING WEB PAGE
    print "<META HTTP-EQUIV=Refresh CONTENT=\"5\">";   
    print "</head>";
    print "<body>";
    print "<center>";
    print "<table border=0>";
    print "<tr><td>";
    print "Your processing/transaction #: $processNum";
	print "<form name=processing>";
    print "<textarea name=puffProcessing rows=27 cols=80 readonly=readonly>";
    
    # PRINT OUT THE CONTENTS OF A PROCESSING/STATUS DISPLAY FILE
    my $dispFile = $sate_puff_dir."/".$processNum."_webDisplay.txt";
    
    # OPEN THE PROCESSING/STATUS DISPLAY FILE
    open(MYDATA, $dispFile) or die ("Error: cannot open file $dispFile ");
    
    # EXTRACT THE TEXT DATA FROM THE FILE
    my @lines = <MYDATA>;

    # PRINT OUT THE TEXT DATA
    print "@lines";

    # CLOSE THE FILE
    close MYDATA;
    
    # FINISH OUTPUTTING THE HTML FILE
    print "</textarea>";
    print "</form>";
    print "</td></tr>";
    print "</table>";
    print "</center>";
    print "<center>";
    print  "Window will auto refresh every 5 seconds to show progress.";
    print "</center>";
    print "<script type=text/javascript>";
    print "   var str = document.forms.processing.puffProcessing";
    print "    str.scrollTop = str.scrollHeight;" ;
    print "</script>";
    print "</body>";
    print "</html>";
} 



# HAS THE MODEL FINISHED PROCESSING OUR REQUEST?
if ($waiting2Finish == 0)
{
     # IF YES, THEN WRITE THE FOLLOWING WEB PAGE    
    print "</head>";
    print "<body>";
    
    print "<center>";
    print "<table border=0>";
    print "<tr><td>";
    print "Your processing/transaction #: $processNum";
	print "<form name=processing>";
    print "<textarea name=puffProcessing rows=27 cols=80 readonly=readonly>";

    # PRINT OUT THE CONTENTS OF A PROCESSING/STATUS DISPLAY FILE
    my $dispFile = $sate_puff_dir."/".$processNum."_webDisplay.txt";

    # OPEN THE PROCESSING/STATUS DATA FILE
    open(MYDATA, $dispFile) or die ("Error: cannot open file $dispFile ");

    # EXTRACT THE TEXT DATA
    my @lines = <MYDATA>;
    
    # PRINT OUT THE TEXT DATA
    print "@lines";

    # CLOSE THE FILE
    close MYDATA;

    # FINISH OUTPUTTING THE HTML FILE
    print "</textarea>";
    print "</form>";
    print "</td></tr>";
    print "</table>";
    print "</center>";
    print "<center>";
    print  "<a href=displayResults.pl?processNum=$processNum> View Results </a>";
    print "</center>";
    print "<script type=text/javascript>";
    print "   var str = document.forms.processing.puffProcessing";
    print "    str.scrollTop = str.scrollHeight;" ;
    print "</script>";
    print "</body>";
    print "</html>";
    
    # WE ARE FINISHED, SO LET'S DELETE THE INPUT DATA FILE 
    # USED IN THIS TRANSACTION
    unlink("inputFiles/puffRun_".$processNum.".dat");

    
}





