#!/usr/bin/perl -w


#==============================================================
# SCRIPT:       lastday
#
# DESCRIPTION:  Used to compute the number of days in a month.
#
# DEPENDENCIES: N/A
#
# INPUTS:  year:   A given year
#          month:  A given month
#               
# OUTPUTS:  feblength: The length of the a feburary leap year
#                      (no always an output)
#           mlength:   The length of the month (in days)
#
#==============================================================  


# RETRIEVE THE INPUTTED INFORMATION
$year=$ARGV[0];  # THE INPUTTED YEAR
$month=$ARGV[1];    # THE INPUTTED MONTH


# CONSTRUCT AN ARRAY OF "NUMBER OF DAYS IN EACH MONTH"
$mlength[0]=00;   # xx
$mlength[1]=31;   # January
$mlength[2]=28;   # Feburary
$mlength[3]=31;   # March
$mlength[4]=30;   # April
$mlength[5]=31;   # May
$mlength[6]=30;   # June
$mlength[7]=31;   # July
$mlength[8]=31;   # August
$mlength[9]=30;   # September
$mlength[10]=31;  # October
$mlength[11]=30;  # November
$mlength[12]=31;  # December


# MAKE SURE THE YEAR IS WITHIN THE VALID JULIAN
     #   DATE RANGE
if (( $year < 1860 || $year > 3999)) {
    print "year out of range";
    exit 1;
}


# MAKE SURE THE MONTH IS VALID
if (( $month < 1 || $month > 12 )) {
    print "month out of range";
    exit 1;
}

# IF WE'RE NOT DEALING WITH FEBURARY, THEN
#   GET THE NUMBER OF DAYS FROM THE
#   "NUMBER OF DAYS IN EACH MONTH" ARRAY
if (($month != 2)) {
    print "$mlength[$month] \n";
    exit 0;
}

# SET A "IS LEAP YEAR?" VARIABLE INITIALLY TO ZERO (NO)
$leap=0;
     
# CHECK TO SEE IF THE INPUTTED YEAR IS A LEAP YEAR
if ((!($year%100))) {
    
    if (!($year%400)) {
	$leap=1;
    }
}
else {
    if (!($year%4)) {
	$leap=1;
    }
}

# DEFINE NUMBER OF DAYS IN FEBRUARY
$feblength=28;

# IF THE INPUTTED YEAR IS A LEAP YEAR, THEN 
#   ADJUST THE LENGTH OF FEBURARY
if ($leap) {
    $feblength=29;	 
}

print "$feblength \n";

#########################################################################
