#!/usr/bin/perl -w

#==============================================================
# SCRIPT:       getRegionLimits.pl
#
# DESCRIPTION:  Retrieve the mapping limits for a given region.
#
# DEPENDENCIES: N/A
#
# INPUTS:  region:  Region of interest
#               
# OUTPUTS: An output string in the following format:
#          "lat_min,lat_max,lon_min,lon_max"
#
#==============================================================  


# RETRIEVE THE INPUT DATA
my $region = $ARGV[0];   


# PRINT THE FOLLOWING:  
# LAT_MIN LAT_MAX LON_MIN LON_MAX 

# DEFINE A FLAG TO TRACK IF THE REGION WAS FOUND
my $flag = 0;

# THE ALASKA REGION
if ($region eq "Alaska")
{
    print "52,64,-166,-134";
    $flag=1;
} 

# THE ALEUTIAN REGION
if ($region eq "Aleutian")
{
    print "42,63,168,210";
    $flag=1;
}

# THE ANATAHAN REGION
if ($region eq "Anatahan")
{
    print "21,10,139,153";
    $flag=1;
}

# THE CASCADE REGION
if ($region eq "Cascade") 
{
    print "40,53,-140,-109";
    $flag=1;
}                                                                                                                  
# THE CENTRAL AMERICA REGION
if ($region eq "Central_America")
{
    print "6,18,-93,-79";
    $flag=1;
}

# THE COMORO REGION
if ($region eq "Comoro")
{
    print "-17,-7,38,52";
    $flag=1;
}

# THE ECUADOR REGION
if ($region eq "Ecuador")
{
    print "-5,5,-86,-72";
    $flag=1;
}

# THE ETNA REGION
if ($region eq "Etna")
{
    print "35,46,8,26";
    $flag=1;
}

# THE GALAPAGOS REGION
if ($region eq "Galapagos")
{
    print "-5,5,-97,-83";
    $flag=1;
}

# THE HAWAII REGION
if ($region eq "Hawaii")
{
    print "14,24,-164,-150";
    $flag=1;
}

# THE JAPAN REGION
if ($region eq "Japan")
{
    print "30,44,126,150";
    $flag=1;
}

# THE JAVA REGION
if ($region eq "Java")
{
    print "-28,2,85,135";
    $flag=1;
}

# THE KAMCHATKA REGION
if ($region eq "Kamchatka")
{
    print "45,59,140,174";
    $flag=1;
}

# THE MEXICO REGION
if ($region eq "Mexico")
{
    print "15,25,-105,-90";
    $flag=1;
}

# THE MONTSERRAT REGION
if ($region eq "Montserrat")
{
    print "10,20,-70,-56";
    $flag=1;
}

# THE NORTH CHILE REGION
if ($region eq "North_Chile")
{
    print "-30,-17,-76,-56";
    $flag=1;
}

# THE NYIRAGONGO REGION
if ($region eq "Nyiragongo")
{
    print "-8,4,22,38";
    $flag=1;
}

# THE PERU REGION
if ($region eq "Peru")
{
    print "-20,-13,-79,-65";
    $flag=1;
}

# THE PHILIPPINES REGION
if ($region eq "Philippines")
{
    print "6,16,116,130";
    $flag=1;
}

# THE PAPUA NEW GUINEA REGION
if ($region eq "Papua_New_Guinea")
{
    print "-10,0,144,158";
    $flag=1;
}

# THE REUNION REGION
if ($region eq "Reunion")
{
    print "-26,-16,49,63";
    $flag=1;
}

# THE SOUTH CHILE REGION
if ($region eq "South_Chile")
{
    print "-47,-36,-78,-58";
    $flag=1;
}

# THE VANATU REGION
if ($region eq "Vanatu")
{
    print "-24,-10,157,177";
    $flag=1;
}

# THE SULAWESI SANGIHE REGION
if ($region eq "Sulawesi_Sangihe")
{
    print "-4,9,114,134";
    $flag=1;
}

# THE NEW ZEALAND REGION
if ($region eq "New_Zealand")
{
    print "-50,-33,156,188";
    $flag=1;
}

# THE READ SEA REGION
if ($region eq "Red_Sea")
{
    print "4,21,28,52";
    $flag=1;
}

# THE TANZANIA REGION
if ($region eq "Tanzania")
{
    print "-10,7,22,48";
    $flag=1;
}

# THE EASTERN CHINA REGION
if ($region eq "Eastern_China")
{
    print "26,40,104,130";
    $flag=1;
}

# THE ICELAND REGION
if ($region eq "Iceland")
{
    print "56,71,-46,6";
	$flag=1;
}

# THE NORTH WEST EUROPE REGION
if ($region eq "North_West_Europe")
{
    print "40,62,-14,34";
    $flag=1;
}

# THE NORTHERN ATLANTIC REGION
if ($region eq "Northern_Atlantic")
{
    print "38,72,-68,30";
    $flag=1;
}

# IF NOTHING WAS FOUND, PRINT OUT AN ERROR MESSAGE.
if ($flag == 0)
{
    print "None_Found";
}


