#!/usr/bin/perl -w

################################################################################
#-------------------------------------------------------------------------------
#  NAME:         wait4Pickup.pl
# 
#  TYPE:         perl Script 
#
#  DESCRIPTION:  Output an estimated "waiting time"  until the processing starts
#
#  DEPENDENCES:  getLogFile.pm     
#     
#  INPUTS:       N/A
#      
#  OUTPUTS:      N/a
#
#  HISTORY:
# 
#
#-------------------------------------------------------------------------------
################################################################################


# SET FOR USAGE WITH THE CGI-BIN
use CGI;
use CGI::Carp qw(warningsToBrowser fatalsToBrowser); 
use CGI qw(:standard);


# RETRIEVE A SET OF FUNCTIONS USED TO READ AND WRITE TO 
# LOG FILES
require "getLogFile.pm";

# GET THE WEB-BASED CGI PATH
my $cgi_dir = getCgiDir();

# GET THE SYSTEM OUTPUT DIRECTORY
my $sate_puff_dir = getDispDir();

# CHECK TO SEE IF ANOTHER PROCESS IS WAITING TO BE RUN
my $waiting4Puff = &getWaitingLog();

# RETRIEVE THE CURRENT TRANSACTION NUMBER FROM THE 'POST'
my $processNum = param("processNum");

# CHECK TO SEE IF THE PROCESSING ON THE MODEL SERVER HAS BEGUN
my $waiting2Begin = &getBegunLog();

# THE AMOUNT OF TIME (MINUTES) THAT THE CRONTAB WILL WAIT UNTIL
#   THE REQUESTS ON SATEESPANONE ARE RE-CHECKED
my $cronTabInterval = 1;


# ARE WE WAITING FOR THE MODEL SERVER TO "PICK-UP" OUR REQUEST?
if ($waiting2Begin == 0)
{

    # IF YES, THEN WRITE THE FOLLOWING WEB PAGE
    print "Content-type: text/html\n\n";
    print "<html>";
    print "<head>";
    print "Content-type: text/html\n\n";    
    print "<html>";
    print "<head>";
    print "<META HTTP-EQUIV=Refresh CONTENT=\"5\">";
    print "</head>";
    print "<body>";
    print "<center>";
    print "Waiting for processes to begin ... ";
    

    # GET THE LAST TIME THAT THE MODEL SERVER CHECK FOR ANY REQUESTS
    my $cTime = &getCheckTime();
    
    @fullTime = split(/-/,$cTime);
    
    my $logYYYY = $fullTime[0];
    my $logMM   = $fullTime[1];
    my $logDD   = $fullTime[2];
    my $logHH   = $fullTime[3];
    my $logMn   = $fullTime[4];
    my $logSS   = $fullTime[5];

    # GET THE CURRENT TIME
    my $currYYYY =  `date +%Y`;
    my $currMM =    `date +%m`;
    my $currDD =    `date +%d`;
    my $currHH =    `date +%H`;
    my $currMn =    `date +%M`;
    my $currSS =    `date +%S`;

    # REMOVE NEW-LINE CHARACTERS
    chomp($currYYYY);
    chomp($currMM);
    chomp($currDD);
    chomp($currHH);
    chomp($currMn);
    chomp($currSS);
    
    # CONVERT THE CURRENT TIME AND LOG TIME INTO A JULIAN DATE/TIME
    my $logJulDate  = `/usr/bin/perl getJulDate.pl $logYYYY $logMM $logDD $logHH $logMn`;
    my $currJulDate = `/usr/bin/perl getJulDate.pl $currYYYY $currMM $currDD $currHH $currMn`;

    # ADD THE NUMBER OF SECONDS TO THE JULIAN DATES (AS A FRACTION OF THE DAY)
    $logJulDate  = $logJulDate + ($logSS / (60 * 60 * 24));
    $currJulDate = $currJulDate + ($currSS / (60 * 60 * 24));

    # GET THE DIFFERENCE BETWEEN THE TWO TIMES
    my $diffJulDate = $currJulDate - $logJulDate;

    # SUBTRACT THE CRONTAB INTERVAL (IN MINUTES) FROM THIS DIFFERENCE
    $diffJulDate = ($cronTabInterval / (60 * 24)) - $diffJulDate;

    # CONVERT THIS TIME DIFFERENCE INTO MINUTES
    my $minsLeft = $diffJulDate * 24 * 60;

    $minsLeft = sprintf("%2.1f", $minsLeft);

    print "<br>";
    print "<br>";
    print "<br> Your requested process should begin in approximately:<b>  $minsLeft Minutes </b>";

#      print "waitingLog:  $waiting4Puff";
#    print "<br> ";
#    print "begunLog:    $waiting2Finish";

    print "</center>";
    print "</body>";
    print "</html>";
} else {

    # THE MODEL SERVER HAS PICKED UP OUR REQUEST! MOVE TO 
    # A DIFFERENT WEB PAGE TO TRACK THE MODEL'S PROGRESS

    # INDICATED IN THE LOG FILE THAT WE ARE NO LONGER WAITING
    # FOR THE MODEL SERVER TO BEGIN PROCESSING
    &writeWaitingLog("0");
    
    # REDIRECT THE USER TO A DIFFERENT WEB PAGE
    print "Location: http://satepsanone.nesdis.noaa.gov/$cgi_dir/checkProgress.pl?processNum=".$processNum."\n\n";

}




    
  







